<?php
/**
*
* @package acp
* @version $Id: acp_cash.php 54 2008-07-13 20:25:23Z Handyman $
* @copyright (c) 2008 StarTrekGuide Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_cash
{
	var $u_action;

	function main($id, $mode)
	{
		global $template, $db, $user, $config, $cash;

		$this->tpl_name = 'mods/cash/acp_cash';
		$user->add_lang('mods/cash_mod');

		$action = request_var('action', '');
		$form_key = 'acp_cash';
		add_form_key($form_key);

		switch ($mode)
		{
			case 'bank':
			break;

			case 'settings':
				$cash_id = request_var('cash_id', 0);

				if ($action == 'edit_currency' && $cash_id)
				{
					$row = $cash->get_currencies($cash_id, false, 'all');

					$template->assign_vars(array(
						'CASH_ID'		=> $row['cash_id'],
						'CASH_NAME'		=> $row['cash_name'],
						'CASH_DONATE'	=> (($row['cash_donate']) ? 'checked="checked"' : ''),
						'CASH_EXCHANGE'	=> (($row['cash_exchange']) ? 'checked="checked"' : ''),

						'S_CASH_EDIT'	=> true,
					));

				}
				else if ($action == 'delete_currency' && $cash_id)
				{
					// verify that we want to delete this account first
					// if we say yes, we have to transfer all user funds from this currency to another with the exchange rate minus the fees
					trigger_error('DELETE_CURRENCY');
				}
				else if (isset($_POST['add_currency']) && check_form_key($form_key))
				{
					$sql_ary = array(
						'cash_name'		=> utf8_normalize_nfc(request_var('cash_name', '', true)),
						'cash_donate'	=> request_var('cash_donate', false),
						'cash_exchange'	=> request_var('cash_exchange', false),
					);

					$sql = 'INSERT INTO ' . CASH_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);

					$cash_name = (isset($user->lang[$sql_ary['cash_name']]) ? $user->lang[$sql_ary['cash_name']] : $sql_ary['cash_name']);

					// now insert into the rates table
					$sql_ary = array(
						'cash_id'			=> $db->sql_nextid(),
						'exchange_rate'		=> request_var('cash_value', 1.00),
						'exchange_fee'		=> request_var('exchange_fee', 1.00),
						'exchange_percent'	=> request_var('exchange_percent', 1.00),
					);

					$sql = 'INSERT INTO ' . CASH_RATES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
					$db->sql_query($sql);

					trigger_error(sprintf($user->lang['CURRENCY_ADDED'], $cash_name) . adm_back_link($this->u_action));
				}
				else if (isset($_POST['edit_currency']) && $cash_id && check_form_key($form_key))
				{
					$sql_ary = array(
						'cash_name'		=> utf8_normalize_nfc(request_var('cash_name', '', true)),
						'cash_donate'	=> request_var('cash_donate', false),
						'cash_exchange'	=> request_var('cash_exchange', false),
					);

					$sql = 'UPDATE ' . CASH_TABLE . '
						SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
						WHERE cash_id = ' . $cash_id;
					$db->sql_query($sql);

					trigger_error(sprintf($user->lang['CURRENCY_UPDATED'], (isset($user->lang[$sql_ary['cash_name']]) ? $user->lang[$sql_ary['cash_name']] : $sql_ary['cash_name'])) . adm_back_link($this->u_action));
				}
				else if (isset($_POST['update_settings']) && check_form_key($form_key))
				{
					$new_config = array(
						'cash_display_name'			=> $cash->get_currencies(request_var('cash_display_currency', 1)),
						'cash_display_currency'		=> request_var('cash_display_currency', 1),
						'cash_topic'				=> request_var('cash_topic', 1.00),
						'cash_topic_per_word'		=> request_var('cash_topic_per_word', 1.00),
						'cash_topic_per_character'	=> request_var('cash_topic_per_character', 1.00),
						'cash_post'					=> request_var('cash_post', 1.00),
						'cash_post_per_word'		=> request_var('cash_post_per_word', 1.00),
						'cash_post_per_character'	=> request_var('cash_post_per_character', 1.00),
						'cash_poll'					=> request_var('cash_poll', 1.00),
						'cash_poll_per_option'		=> request_var('cash_poll_per_option', 1.00),
						'cash_attachment'			=> request_var('cash_attachment', 1.00),
						'cash_attachment_per_file'	=> request_var('cash_attachment_per_file', 1.00),
						'cash_display_currency'		=> request_var('cash_display_currency', 1),
						'cash_topic_currency'		=> request_var('cash_topic_currency', 1),
						'cash_post_currency'		=> request_var('cash_post_currency', 1),
						'cash_poll_currency'		=> request_var('cash_poll_currency', 1),
						'cash_attachment_curency'	=> request_var('cash_attachment_currency', 1),
					);

					foreach ($new_config as $key => $var)
					{
						if ($config[$key] != $var)
						{
							set_config($key, $var);
							$config[$key] = $var;
						}
					}
				}
				else if (isset($_POST['update_rates']) && check_form_key($form_key))
				{
					//
				}

				$this->page_title = 'CASH_SETTINGS';

				// display currencies
				$currencies = $cash->get_currencies();

				foreach ($currencies as $row)
				{
					$template->assign_block_vars('cash', array(
						'CASH_ID'		=> $row['cash_id'],
						'CASH_NAME'		=> (isset($user->lang[$row['cash_name']]) ? $user->lang[$row['cash_name']] : $row['cash_name']),
						'CASH_DONATE'	=> $row['cash_donate'],
						'CASH_EXCHANGE'	=> $row['cash_exchange'],

						'U_DELETE'		=> $this->u_action . '&amp;cash_id=' . $row['cash_id'] . '&amp;action=delete_currency',
						'U_EDIT'		=> $this->u_action . '&amp;cash_id=' . $row['cash_id'] . '&amp;action=edit_currency',
					));
				}

				// display rates
				global $bank;
				$rates = $bank->get_rates();

				foreach ($rates as $row)
				{
					$template->assign_block_vars('rates', array(
						'CASH_ID'			=> $row['cash_id'],
						'CASH_NAME'			=> (isset($user->lang[$row['cash_name']]) ? $user->lang[$row['cash_name']] : $row['cash_name']),
						'EXCHANGE_RATE'		=> $row['exchange_rate'],
						'EXCHANGE_FEE'		=> $row['exchange_fee'],
						'EXCHANGE_PERCENT'	=> $row['exchange_percent'],
					));
				}

				$template->assign_vars(array(
					'CASH_TOPIC'				=> $config['cash_topic'],
					'CASH_TOPIC_PER_WORD'		=> $config['cash_topic_per_word'],
					'CASH_TOPIC_PER_CHARACTER'	=> $config['cash_topic_per_character'],
					'CASH_POST'					=> $config['cash_post'],
					'CASH_POST_PER_WORD'		=> $config['cash_post_per_word'],
					'CASH_POST_PER_CHARACTER'	=> $config['cash_post_per_character'],
					'CASH_POLL'					=> $config['cash_poll'],
					'CASH_POLL_PER_OPTION'		=> $config['cash_poll_per_option'],
					'CASH_ATTACHMENT'			=> $config['cash_attachment'],
					'CASH_ATTACHMENT_PER_FILE'	=> $config['cash_attachment_per_file'],

					'U_ACTION'					=> $this->u_action,
					'S_CASH_DISPLAY_CURRENCY'	=> $cash->get_currencies($config['cash_display_currency'], true),
					'S_TOPIC_CURRENCY'			=> $cash->get_currencies($config['cash_topic_currency'], true),
					'S_POST_CURRENCY'			=> $cash->get_currencies($config['cash_post_currency'], true),
					'S_POLL_CURRENCY'			=> $cash->get_currencies($config['cash_poll_currency'], true),
					'S_ATTACHMENT_CURRENCY'		=> $cash->get_currencies($config['cash_attachment_currency'], true),
					'S_CASH_SETTINGS'			=> true,
					'S_CASH_RATES'				=> true,
				));
			break;
			case 'users':
			break;
		}
	}
}