<?php
/**
*
* @package ucp
* @version $Id: ucp_bank.php 51 2008-07-06 22:53:55Z Handyman $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* ucp_activate
* User activation
* @package ucp
*/
class ucp_bank
{
	var $u_action;

	function main($id, $mode)
	{
		global $user, $cash, $template, $phpbb_root_path, $phpEx, $db;

		$user->add_lang('mods/cash_mod');
		$this->page_title = 'UCP_BANK_' . strtoupper($mode);
		$this->tpl_name = 'mods/bank/ucp_bank_' . $mode;

		$submit = (isset($_POST['submit'])) ? true : false;
		$user_id = request_var('user_id', 0);
		$form_key = 'ucp_bank';
		add_form_key($form_key);

		switch ($mode)
		{
			case 'donate':
				if (!$user_id)
				{
					trigger_error('NO_USER_SELECTED');
				}

				include($phpbb_root_path . 'includes/functions_display.' . $phpEx);

				// get the user data for the person we're donating to
				$sql = 'SELECT username, user_colour
					FROM ' . USERS_TABLE . '
					WHERE user_id = ' . $user_id;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$username = get_username_string('full', $user_id, $row['username'], $row['user_colour']);

				if ($submit && check_form_key($form_key))
				{
					$donation_amount = request_var('donation_amount', 1.00);

					if ($cash->donate($user->data['user_id'], $user_id, $donation_amount, request_var('donate_currency', 1)))
					{
						trigger_error(sprintf($user->lang['DONATION_SUCCESSFUL'], $donation_amount, $username));
					}
					else
					{
						trigger_error('DONATION_FAILED');
					}
				}

				$users_cash = $cash->get_user_cash($user_id, false);
				$donate_currency = $cash->get_user_cash($user->data['user_id'], false);

				// put users cash into a dropdown list
				$s_users_cash = '';
				foreach ($users_cash as $row)
				{
					$s_users_cash .= '<option value="' . $row['cash_id'] . '">' . $row['cash_name'] . ' - ' . $row['cash_amt'] . '</option>';
				}

				// put our cash into a dropdown list
				$s_donate_currency = '';
				foreach ($donate_currency as $row)
				{
					$s_donate_currency .= '<option value="' . $row['cash_id'] . '">' . $row['cash_name'] . ' - ' . $row['cash_amt'] . '</option>';
				}

				$template->assign_vars(array(
					'USERNAME'			=> $username,
					'USERS_CASH'		=> sprintf($user->lang['USERS_CASH'], $username),
					'S_USERS_CASH'		=> $s_users_cash,
					'S_DONATE_CURRENCY'	=> $s_donate_currency,
				));
			break;
		}

	}
}

?>